# WIP: Vlastnosti systému

> Draft

Mezi hlavní přínosy systému patří **navázání procesů ve výuce na procesy, které
fungují v praxi**. Tedy aby postupy a metody, které budou absolventi používat
v praxi byly tytéž postupy a metody, se kterými se setkávají už jako studenti
ve výuce. Pro učitele je hlavním přínosem systému odstínění od rutinních
akcí (např. testování studentských řešení).

Na úrovni celé fakulty může použití sytému mít následující přínosy:

- **Nevytváření závislosti na dodavateli (vendor-lock-in)**  
  Systém je open-source a vytváření kurzů a podpůrných nástrojů je možné
  vlastními prostředky. Systém využívá gitlab, který může být provozován
  v rámci stávajícího fakultního gitlabu, separátního fakultního gitlabu nebo
  zcela externě.

- **Používání standardních nástrojů a postupů**  
  Systém na pozadí používá nástroje a postupy (např. git, gitlab, CI,
  badges, *flow), které jsou v průmyslu standardem a mají bohatou historii
  a stabilitu.

- **Zjednodušení inovací předmětů**  
  Důsledkem nasazení systému do výuky může být automatizace vyhodnocování
  úkolů. To může uvolnit ruce učitelům (odstranit pracnost vyhodnocování) a
  umožní z učitelům věnovat se inovacím. Zároveň systém umožňuje upravovat
  (inovovat) zadání úkolů v průběhu semestru a tím implementovat změny a
  inovace mnohem rychleji (již v průběhu jednoho semestru).

- **Konsolidace investic do výukových systémů**  
  Systémů umožňuje budovat podpůrné systémy pro různé předměty na společném
  základu a neduplikovat stejné části systémů a související procesy.
  To usnadní a zlevní jak vývoj tak údržbu takových řešení a sejme závislost
  takových řešení na jeho autorech.

- **Vytvoření solidního základu pro další rozvoj**  
  Nad systémem je již nyní možné stavět dílčí řešení nebo integrovat existující
  řešení, např. galerie nebo kontrolu plagiarizmů. Jelikož je systém otevřený,
  bude možné v budoucnosti přemýšlet i o jeho dalších rozšíření,
  např. zapojení AI.


## Přínosy pro studenty

- Přístupy z praxe ve výuce
- Kontrola nad odevzdávanými daty (úlohami)
- Průběžné testování řešení a zpětná vazba při vývoji řešení
- Řízení práce v semestru ve vlastním tempu
- Tvorba portfolia projektů pro snadnější vstup do praxe
- Lokální práce nad předpřipraveným prostředím
- Lokálně uložené a přístupné zadání včetně vstupních, případně testovacích
  dat
- Lokálního testování řešení před odevzdáváním
- Výsledek je integritní součástí zadání
- Přenos souborů (včetně pracovních) standardní cestou (mezi školou a domovem,
  mezi studentem a učitelem)
- Zpětná vazba k řešení od učitele
- Diskuze k řešení standardní a přístupnou formou


## Přínosy pro učitele

- Odstínění od rutinních činností
- Distribuce zadání studentům a jeho aktualizace
- Automatizace testování studentských řešení (evaluace)
- Automatizace práce se studentskými daty (např. galerie, přehledy)
- Přehled o průběžné činnosti studentů (filtrování a řazení úloh)
- Kontrola studentských prací ke zvolenému termínu
- Zapojení případných testů plagiarizmu
- Použití gitlab-pages (pro data zadání nebo studentských výstupů)
- Tvorba vlastních docker images na základě jednoduché definice
  prostředí a jejich následné uložení a použití napříč předměty
- Komentáře ke studentskému řešení a případná diskuze jakou součást repozitáře
  (nedohledává se komunikace v teamsech nebo v e-mailu)
